package footyquiz.server.integration;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Methods for creating SQL statements from objects an reading sql results from 
 * ArrayList to objects
 *
 * @author Hannu Leinonen
 * @version 0.2
 */
public class QuestionDAO {
    private DatabaseConnector db;
    private final String SELECT_QUESTIONS = "SELECT q.text AS text, w.text AS wrong_1, w2.text AS wrong_2, r.text AS right_1 FROM question q " +
    		"JOIN answer w ON q.wrong_answer = w.id " +
    		"JOIN answer w2 ON q.wrong_answer2 = w2.id " +
    		"JOIN answer r ON q.right_answer = r.id " +
    		"WHERE q.theme_id LIKE ? AND q.level = ? " +
    		"ORDER BY RAND() LIMIT 0,10";
   
    @SuppressWarnings("unchecked")
	public List<Map> getQuestions(int theme, int difficulty) {
    	db = new DatabaseConnector();
    	List<String> l = new ArrayList<String>();
    	if(theme == 3)
    		l.add("%");
    	else
    		l.add(theme + "");
    	l.add(difficulty + "");
    	return db.executeQuery(SELECT_QUESTIONS, l, true);
    }
}